uses crt,dos;

var S,F,TF,PATH:string;
    C:char;
    EF:text;
    FIL:file;
    DNA,FNF,MDF:longint;
    BUF:array[1..63000] of char;
    NUMREAD,T,ATTR:word;

procedure Beep;
begin
  sound(1500);
  delay(100);
  sound(500);
  delay(50);
  nosound
end;

function Hexa(S:longint):string;
const HTABLE:array[0..15] of char =
             ('0','1','2','3','4','5','6','7','8','9',
              'A','B','C','D','E','F');
begin
  if S<>0 then Hexa:=Hexa(S div 16) + HTABLE[S mod 16] else Hexa:=''
end;

function CSureDIR(S:string):boolean;
var ATTR:word;
    F:file;
begin
  if (length(S)>3) and (S[length(S)]='\') then S:=copy(S,1,length(S)-1);
  assign(F,S);
  getfattr(F,ATTR);
  if ATTR and directory<>0 then CSureDIR:=true else CSureDIR:=false
end;

begin
  FNF:=0;
  MDF:=0;
  S:='';
  PATH:='';
  textattr:=7;
  checkbreak:=false;

  writeln('DNA Checker 1.10, Copyright 1993 by Pentagram. (KIM, JIN HONG)');
  assign(EF,'C:\FDC.VCD');

  {$I-}
  reset(EF);
  if ioresult<>0 then
  begin
    Beep;
    writeln('Before run DCWRITE.');
    halt
  end;
  {$I+}

  while not eof(EF) do
  begin
    read(EF,C);
    if not eoln(EF) then S:=S+C
    else begin
      S:=S+C;
      delete(S,1,2);

      if S[1]=']' then PATH:=copy(S,2,length(S)-1);
      if (PATH<>'') or (length(PATH)>3) then
      begin
        IF S='DONE' then
        begin
          close(EF);
          writeln(MDF,' File(s) modified, ',FNF,' File(s) not found.');
          halt
        end;

        F:=copy(S,1,pos(',',S)-1);
        if not CSureDIR(PATH+F) then write('Checking ',PATH+F);

        DNA:=0;
        assign(FIL,PATH+F);
        {$I-}
        reset(FIL,1);
        if ioresult=0 then
        begin
          repeat
            blockread(FIL,BUF,sizeof(BUF),NUMREAD);
            for T:=1 to NUMREAD do inc(DNA,ord(BUF[T]))
          until NUMREAD=0;

          gotoxy(1,wherey);
          clreol;
          TF:=copy(S,pos(',',S)+1,length(S)-length(F)-1);
          if (Hexa(DNA)<>TF) and (pos('FDC.VCD',F)=0) then
          begin
            Beep;
            write('[ ',F+' ] ');
            textattr:=15;
            inc(MDF);
            writeln('Modified!');
            textattr:=7
          end;
          close(FIL)
        end else if not CSureDIR(PATH+F) then
        begin
          Beep;
          textattr:=15;
          inc(FNF);
          writeln(' File not found.');
          textattr:=7
        end;
        {$I+}
        S:=''
      end
    end
  end
end.