{$R-}

program  MouseTester;

uses graph,bgidriv,PMU;

var GD,GM,EC,C:integer;
    OP,HC,LC,MB:byte;
    X1,Y1,X2,Y2:word;

procedure Swap(var A,B:word);
var T:word;
begin
  T:=A;
  A:=B;
  B:=T
end;

begin
  if registerbgidriver(@EGAVGADriverProc)<0 then halt;

  if not ReadyMouse then
  begin
    writeln('Mouse Driver NOT found.');
    halt
  end;

  GD:=detect;
  initgraph(GD,GM,'');
  EC:=graphresult;
  if EC<>grok then writeln('Graphics error:',grapherrormsg(EC));

  writeln('Mouse Tester 2.11, Copyright 1992, 1993 by Pentagram. (KIM, JIN HONG)');
  writeln('Mouse button number is ',ButtonNumber);
  writeln('Left button: next, Right button: draw.');

  MouseWindow(0,0,640,480);
  MouseMove(320,240);
  MouseCursor(true);

  C:=0;
  repeat
    MB:=MouseButton;
    if MB=2 then
    begin
      case C of
        1:GetMouseXY(X1,Y1);
        200:begin
               GetMouseXY(X2,Y2);
               line(X1,Y1,X2,Y2);
               C:=0
             end
      end;
      inc(C)
    end
  until MB=1;

  cleardevice;

  writeln('Mouse cursor move in rectangle box!');
  writeln('Press left and right button at same time to EXIT.');

  CursorChange;
  MouseCursor(false);
  MouseMove(250,250);
  setcolor(9);
  rectangle(100,100,400,400);
  setcolor(15);
  rectangle(102,102,402,402);
  rectangle(160,160,200,200);
  MouseWindow(100,100,400,400);
  MouseCursor(true);

  OP:=port[97];
  randomize;
  repeat
    GetMouseXY(X1,Y1);
    if (X1 in [160..200]) and (Y1 in [160..200]) then
    begin
      for GM:=1 to 100 do
      begin
        C:=1193180 div (random(200)+180);
        LC:=C mod 256;
        HC:=C div 256;
        port[67]:=182;
        port[66]:=LC;
        port[66]:=HC;
        port[97]:=OP or $03
      end;
      port[97]:=OP
    end
  until MouseButton=3;

  MouseWindow(0,0,640,480);
  closegraph;

  MouseMove(0,0);
  MouseWindow(0,0,639,199);
  writeln('Now screen is text mode...');
  writeln('Press the right mouse button to EXIT.');

  repeat until MouseButton=2;
  MouseCursor(false)
end.


