var drive,count,scount:byte;

procedure parking(drive:byte);
begin
   { get drive parameters }
   asm
        mov     ah,8h
        mov     dl,drive
        int     13h

{ return:   CH = low eight bits of maximum cylinder number
	    CL = maximum sector number (bits 5-0)
		 high two bits of maximum cylinder number (bits 7-6)
	    DH = maximum head number
	    DL = number of drives}

{ input: CH = low eight bits of cylinder number
         CL = sector number (bits 5-0)
	    high two bits of cylinder number (bits 7-6)
	 DH = head number
	 DL = drive number (80h = first, 81h = second hard disk)}

        mov     ah,0ch
        mov     dl,drive
        int     13h
   end;
end;

begin
  writeln;
  writeln('Hard-disc Parker 1.0.0  (c) KIM, JIN HONG (aromanix)  Push enter to cancel.');
  asm
     mov        drive,10000000b
     mov        ah,8h
     mov        dl,drive
     int        13h
     mov        count,dl { get number of drives }
  end;

  scount:=count;
  repeat
    writeln('Hard disk ',drive-127,' parked!');
    parking(drive);
    inc(drive);
    dec(count);
  until count=0;

  readln;

  count:=scount;
  drive:=$80; { $80 means first drive }
  repeat
    writeln('Hard disk ',drive-127,' park canceled!');
    asm
       mov      ah,0dh
       mov      dl,drive
       int      13h
       inc      drive
       dec      count
    end;
  until count=0;
end.
