uses dos,crt,screen;

var Drive,Park_Ok:word;
    Regs:registers;
    Count:word;

procedure Parking(Drive,Park_ok :Word);
Begin
   Regs.ax := 4352;
   Regs.cx := 0;
   Regs.dx := Drive;
   Intr($13,Regs);

   If Regs.flags <> 0 then Exit;
   Park_ok := 128;

   regs.ax := 3072;
   Regs.cx := 0;
   Regs.Dx := Drive;
   Intr($13,Regs);

   regs.ax := 2048;
   Regs.cx := 0;
   Regs.Dx := Drive;
   Intr($13,Regs);

   regs.ax := 3072;
   Regs.cx := 0;
   Regs.Dx := Drive;
   Intr($13,Regs);
End;

procedure SetPalette(ORG,R,G,B:byte);
begin
  port[$3C8]:=ORG;
  port[$3C9]:=R;
  port[$3C9]:=G;
  port[$3C9]:=B
End;

var R,G,B,RI,GI,BI:byte;
Begin
   Clrscr;
   Park_Ok := 0;
   Drive := $80;

   regs.ax := $800;
   Regs.cx := 0;
   regs.dx := Drive;
   Intr($13,regs);

   Count := Regs.dl;

   If (regs.Flags = 1) or ( Count = 0 ) then begin
     Writeln('Parking Error!');
     Exit
   end else Begin
     If Count > 2 then Count := 2;

     Repeat
        parking(drive,park_ok);
        Inc(Drive);
        Dec(Count)
     Until  Count<>0;

     If Park_Ok = 128 then Begin
       Writeln('Parking Error!');
       Exit
     End;
   end;

  cursor(off);
  RI:=1;
  GI:=1;
  BI:=1;
  R:=0;
  G:=62;
  B:=30;
  fwrite('PENTAGRAM',1,25,8);
  repeat
    inc(R,RI);
    inc(G,GI);
    inc(B,BI);
    if (R=0) or (R=63) then RI:=-RI;
    if (G=0) or (G=63) then GI:=-GI;
    if (B=0) or (B=63) then BI:=-BI;
    delay(50);
    SetPalette(0,R,G,B)
  until false
End.
