{$X+}

uses crt;

function Spc(C:char;T:byte):string;
var I:byte;
    S:string;
begin
  S:='';
  for I:=1 to T do S:=S+C;
  Spc:=S
end;

function UCase(S:string):string;
var T:byte;
begin
  for T:=1 to length(S) do S[T]:=upcase(S[T]);
  UCase:=S
end;

procedure Print(S:string;C,B:byte;M:boolean);
begin
  textattr:=C+16*B;
  write(S);
  textattr:=7;
  if M then writeln
end;

var F:text;
    S:string;
    L:word;
    P,TOT:byte;
begin
  clrscr;
  Print('String Searcher 1.00 by KIM, JIN HONG. NTCG-DESQ Labs',15,1,true);

  if paramcount=0 then begin
    Print('SS [pathname] [string]',11,3,true);
    halt
  end;

  Print('Search string:',9,0,false);
  writeln(paramstr(2));

  assign(F,paramstr(1));
  reset(F);

  L  :=0;
  TOT:=0;
  window(1,5,80,15);

  while not eof(F) do begin
    readln(F,S);
    inc(L);

    P:=pos(ucase(paramstr(2)),ucase(S));

    if P=0 then writeln(S) else begin
      Print(copy(S,1,P-1),15,3,false);
      Print(copy(S,P,length(paramstr(2))),11,5,false);
      Print(copy(S,P+length(paramstr(2)),length(S))+Spc(' ',79-length(S)),
      15,3,true)
    end;

    if P>0 then begin
      inc(TOT);
      writeln('>>>>>>> Low:',L,' Col:',P,' <<<<<<<');
      readkey
    end
  end;

  close(F);
  window(1,1,80,25);
  gotoxy(1,20);

  if TOT=0 then Print('Oh.. Not found!',14,1,true)
  else          writeln('Total ',TOT,' strings found!')
end.
