{                  ASCII CODE / SCAN CODE TABLE v2.0
                            for Programmer

            Copyright 1993, 1994 by KIM, JIN HONG. PENTAGRAM
}

uses screen,hexwrite,keyboard,publvar;

{$R-}

const X      =5;
      Y      =5;
      VERSION='CODE TABLE 2.1, copyright 1993-1995 by snatchkiwi/windgram [kim, jin hong]';

var Indicate,ScanCode:byte;
    Key     :word;

function Scan_Code_Table:string;
var N:string;
begin
  case ScanCode of
    $00:N:='Not Pushed';
    $AA:N:='Print Screen';
    $46:N:='Scroll Lock';
    $D2:N:='Insert';
    $C7:N:='Home';
    $C9:N:='Page Up';
    $D3:N:='Delete';
    $CF:N:='End';
    $D1:N:='Page Down';
    $0F:N:='Tab';
    $3A:N:='Caps Lock';
    $2A:N:='Left Shift';
    $36:N:='Right Shift';
    $1D:N:='Left CTRL';
    $9D:N:='Right CTRL';
    $38:N:='Left ALT';
    $B8:N:='Right ALT';
    $01:N:='ESC';
    $02:N:='! 1';
    $03:N:='@ 2';
    $04:N:='# 3';
    $05:N:='$ 4';
    $06:N:='% 5';
    $07:N:='^ 6';
    $08:N:='& 7';
    $09:N:='* 8';
    $0A:N:='( 9';
    $0B:N:=') 0';
    $0C:N:='_ -';
    $0D:N:='+ =';
    $0E:N:='Back Space';
    $1E:N:='A';
    $1F:N:='S';
    $20:N:='D';
    $21:N:='F';
    $22:N:='G';
    $23:N:='H';
    $24:N:='J';
    $25:N:='K';
    $26:N:='L';
    $27:N:=': ;';
    $28:N:='" ''';
    $29:N:='~ `';
    $10:N:='Q';
    $11:N:='W';
    $12:N:='E';
    $13:N:='R';
    $14:N:='T';
    $15:N:='Y';
    $16:N:='U';
    $17:N:='I';
    $18:N:='O';
    $19:N:='P';
    $1A:N:='{ [';
    $1B:N:='} ]';
    $1C:N:='Enter';
    $CB:N:='Left';
    $CD:N:='Right';
    $C8:N:='Up';
    $D0:N:='Down';
    $45:N:='Num Lock';
    $B5:N:='Keypad /';
    $2B:N:='| \';
    $2C:N:='Z';
    $2D:N:='X';
    $2E:N:='C';
    $2F:N:='V';
    $30:N:='B';
    $31:N:='N';
    $32:N:='M';
    $33:N:='< ,';
    $34:N:='> .';
    $35:N:='? /';
    $39:N:='Space';
    $3B:N:='F1';
    $3C:N:='F2';
    $3D:N:='F3';
    $3E:N:='F4';
    $3F:N:='F5';
    $40:N:='F6';
    $41:N:='F7';
    $42:N:='F8';
    $43:N:='F9';
    $44:N:='F10';
    $57:N:='F11';
    $58:N:='F12';
    $47:N:='Keypad Home 7';
    $48:N:='Keypad Up 8';
    $49:N:='Keypad Page Up 9';
    $4B:N:='Keypad Left 4';
    $4D:N:='Keypad Right 6';
    $4C:N:='Keypad 5';
    $4A:N:='Keypad -';
    $9C:N:='Keypad Enter';
    $4E:N:='Keypad +';
    $4F:N:='Keypad End 1';
    $50:N:='Keypad Down 2';
    $51:N:='Keypad Page Down 3';
    $52:N:='Keypad Insert 0';
    $53:N:='Keypad Delete .';
    $37:N:='Keypad *'
    else N:='What is pushed?'
  end;
  Scan_Code_Table:=N
end;

procedure Draw_Pushed_Name;
var S:string;
begin
  S:=Scan_Code_Table;
  fprint(S+Spc(' ',18-length(S)),X+9,Y+15,Color(15,9));
  fprint(Num2Str(ScanCode),X+16,Y+16,Color(15,0));
  fprint(HexByte(ScanCode),X+29,Y+16,Color(15,0))
end;

procedure DelSLine(X,Y,I:byte);
begin
  fprint(Spc(' ',I),X,Y,0)
end;

procedure PrtSc(ENABLE:boolean);
begin
  mem[$50:$00]:=ord(not ENABLE)
end;

procedure Box(T,L,B,R,CO,BC:byte);
var x,y:byte;
begin
  for x:=l+1 to r-1 do
    for y:=t+1 to b-1 do scrn^[y,x]:=ccw(' ',color(co,bc));

  for y:=t to b do begin
    scrn^[y,l]:=ccw('',color(co,bc));
    scrn^[y,r]:=ccw('',color(co,bc));
  end;
  for x:=l+1 to r-1 do begin
    scrn^[t,x]:=ccw('',color(co,bc));
    scrn^[b,x]:=ccw('',color(co,bc));
  end;
end;

procedure ScreenInit;
var T:byte;
begin
  pushscreen;
  cls;
  BlinkAttrib(off);

  fprint(VERSION,1,1,Color(15,1));
  fprint('To quit press F1 and F2 at the same time.',1,2,Color(11,0));

  box(y-1,x-2,y+8,x+33,15,9);
  fprint(' ASCII Table ',x,y-1,color(0,9));
  for T:=0 to 255 do SCRN^[T div 32+Y,T mod 32+X]:=ccw(chr(t),color(7,1));

  box(Y+10,X-2,Y+12,X+33,15,9);
  fprint(' ASCII Code for Indicator ',x+5,y+10,color(0,9));
  fprint(' [ ] ASCII CODE         HEX ',X,Y+11,Color(14,9));
  DelSLine(X+16,Y+11,3);
  DelSLine(X+29,Y+11,2);

  box(Y+14,X-2,Y+17,X+33,15,9);
  fprint(' Scan Code for Pushed Key ',x+5,y+14,color(15,9));
  fprint(' Pushed: ',X,Y+15,Color(15,9));
  fprint(' SCAN CODE              HEX ',X,Y+16,Color(15,9));
  DelSLine(X+16,Y+16,3);
  DelSLine(X+29,Y+16,2);

  box(Y-1,X+36,Y+7,X+74,15,9);
  fprint(' Keyboard Condition at 417H ',x+40,y-1,color(15,9));
  fprint('Condition bit  76543210 at 417H',X+39,Y,Color(15,9));
  fprint('Integer                  Hex',X+39,Y+1,Color(15,9));
  fprint('7. Insert   ( )  6. CapsLock  ( )',X+39,Y+3,Color(15,9));
  fprint('5. NumLock  ( )  4. ScrollLock( )',X+39,Y+4,Color(15,9));
  fprint('3. ALT      ( )  2. CTRL      ( )',X+39,Y+5,Color(15,9));
  fprint('1. LeftShift( )  0. RightShift( )',X+39,Y+6,Color(15,9));
  DelSLine(X+49,Y+1,3);
  DelSLine(X+70,Y+1,2);

  box(Y+10,X+36,Y+17,X+74,15,9);
  fprint(' NOTICE ',x+45,y+10,color(15,9));
  fprint('Please turn off NumLock key to',X+40,Y+11,Color(14,9));
  fprint('get precise result when you',X+40,Y+12,Color(14,9));
  fprint('wanna know the scan code.',X+40,Y+13,Color(14,9));
  fprint('This program is FREE-ware.',X+40,Y+15,Color(10,9));
end;

procedure Draw_Keyboard_Condition_Bit;
begin
  fprint(BinByte(KeyMem),X+55,Y+1,Color(15,0));
  fprint(Num2Str(KeyMem),X+49,Y+1,Color(15,0));
  fprint(HexByte(KeyMem),X+70,Y+1,Color(15,0));
  if KeyMem and 128<>0 then fprint(#7,X+52,Y+3,Color(15,9))
  else                       fprint(' ',X+52,Y+3,Color(15,9));
  if KeyMem and 64<>0 then fprint(#7,X+70,Y+3,Color(15,9))
  else                      fprint(' ',X+70,Y+3,Color(15,9));
  if KeyMem and 32<>0 then fprint(#7,X+52,Y+4,Color(15,9))
  else                      fprint(' ',X+52,Y+4,Color(15,9));
  if KeyMem and 16<>0 then fprint(#7,X+70,Y+4,Color(15,9))
  else                      fprint(' ',X+70,Y+4,Color(15,9));
  if KeyMem and 8<>0 then fprint(#7,X+52,Y+5,Color(15,9))
  else                     fprint(' ',X+52,Y+5,Color(15,9));
  if KeyMem and 4<>0 then fprint(#7,X+70,Y+5,Color(15,9))
  else                     fprint(' ',X+70,Y+5,Color(15,9));
  if KeyMem and 2<>0 then fprint(#7,X+52,Y+6,Color(15,9))
  else                     fprint(' ',X+52,Y+6,Color(15,9));
  if KeyMem and 1<>0 then fprint(#7,X+70,Y+6,Color(15,9))
  else                     fprint(' ',X+70,Y+6,Color(15,9))
end;

procedure Draw_Indicator;
begin
  mem[_DISPSEG:(Indicate mod 32+x-1)*2+(Indicate div 32+Y-1)*160+1]:=Color(0,14)
end;

procedure Draw_Indicator_Asciicode;
var s:string;
begin
  fprint(chr(Indicate),X+2,Y+11,Color(15,9));
  str(indicate:3,s);
  fprint(s,X+16,Y+11,Color(15,0));
  fprint(Hexbyte(Indicate),X+29,Y+11,Color(15,0))
end;

procedure Indicate_unDraw;
begin
  mem[_DISPSEG:(Indicate mod 32+X-1)*2+(Indicate div 32+Y-1)*160+1]:=Color(7,1)
end;

procedure Inverse;
begin
  mem[_DISPSEG:(Indicate mod 32+x-1)*2+(Indicate div 32+Y-1)*160+1]:=Color(7,8)
end;

var t:byte;
begin
  ScreenInit;
  PrtSc(off);
  Indicate:=0;

  repeat
    Draw_Keyboard_condition_bit;

    Key:=GetKey;
    if key=0 then continue;

    ScanCode:=hi(key);
    Draw_Pushed_Name;
    Indicate_unDraw;

    case hi(Key) of
      72:if Indicate>=32 then dec(Indicate,32) else
            if Indicate=0 then Indicate:=255 else Indicate:=255-(32-Indicate);
      80:if Indicate<=223 then inc(Indicate,32) else
            if Indicate=255 then Indicate:=0 else Indicate:=Indicate+32+1;
      75:if Indicate>0 then dec(Indicate) else Indicate:=255;
      77:if Indicate<255 then inc(Indicate) else Indicate:=0
      else Indicate:=lo(Key)
    end;

    Draw_Indicator;
    Draw_Indicator_Asciicode

  until false;

  BlinkAttrib(on);
  popscreen;
  PrtSc(on)
end.
