uses crt;

const KEY:string='';
      BOJOKEY:string='1a9*.';
      MSG:string='LoftJazz PROTECT.';

var P:string;
    BUF:array[0..60000] of char;
    PC:char;

function JungBok(S:string):boolean;
var CH:array[0..255] of byte;
    CK:boolean;
    T:byte;
begin
  CK:=false;
  for T:=0 to 255 do CH[T]:=0;
  for T:=0 to length(S) do inc(CH[ord(S[T])]);
  for T:=0 to 255 do if CH[T]>1 then CK:=true;
  JungBok:=CK
end;

procedure Print(S:string;C,BC:byte;NL:boolean);
begin
  textattr:=C+BC*16;
  write(S);
  textattr:=7;
  if NL then writeln
end;

procedure IOCheck;
begin
  if ioresult<>0 then begin
    writeln('Input or Output Error!');
    halt
  end
end;

function ReadFile(P:string;INDEX,COUNT:longint):string;
var F:file;
    T:word;
    C:string;
begin
  C:='';
  {$I-}
  assign(F,P);
  reset(F,1);
  IOCheck;
  {$I+}

  blockread(F,BUF,INDEX+COUNT);
  close(F);
  for T:=INDEX to INDEX+COUNT-1 do C:=C+BUF[T];
  ReadFile:=C
end;

function XorModify(C,KEY:char):char;
begin
  XorModify:=chr(ord(C) xor ord(KEY))
end;

function PUP(C:char):char;
var T:byte;
begin
  for T:=1 to length(KEY) do C:=XorModify(C,KEY[T]);
  for T:=1 to length(BOJOKEY) do C:=XorModify(C,BOJOKEY[T]);
  PUP:=C
end;

function PUPC(C:char):char;
begin
  PUPC:=XorModify(C,PC)
end;

procedure Protect;
var FF,TF:file;
    T,NR,NW:word;
    OK:string;
    B:boolean;
begin
  if ReadFile(P,0,length(MSG))=MSG then begin
    Print('Already protected file.',15,3,true);
    halt
  end;

  for T:=0 to length(MSG) do BUF[T]:=MSG[T+1];
  BUF[T+1]:=#26; {eof}

  repeat
    Print('Input PROTECTION Key - ',10,0,false);
    readln(OK);
    B:=JungBok(OK);
    if B then begin
                writeln;
                Print('Exist some same characters!',14,0,true);
                Print('Please Try again.',14,0,true)
    end
  until not B;

  Print('Again Input PROTECTION Key - ',10,0,false);
  readln(KEY);

  if (KEY='') or (OK<>KEY) then begin
    Print('PROTECT Fail!',11,0,true);
    halt
  end;

  assign(FF,P);
  assign(TF,'TEMP.FP$');

  {$I-}
  reset(FF,1);     {source}
  rewrite(TF,1);   {output}
  IOCheck;
  {$I+}

  blockwrite(TF,BUF,length(MSG)+1);  {Write maker message}

  PC:=PUP('.');

  repeat
    blockread(FF,BUF,sizeof(BUF),NR);
    for T:=0 to NR do BUF[T]:=PUPC(PUP(BUF[T]));
    blockwrite(TF,BUF,NR,NW)
  until (NR=0) or (NW<>NR);

  BUF[0]:=PC;
  BUF[1]:=PUP('~');
  blockwrite(TF,BUF,2);

  close(FF);
  close(TF);
  erase(FF);
  rename(TF,P)
end;

procedure UnProtect;
var FF,TF:file;
    T,NR,NW:word;
    OK:string;
begin
  if ReadFile(P,1,17)<>'Pentagram PROTECT' then begin
    Print('No protected file.',15,3,true);
    halt
  end;

  Print('Input old protect key (ASCII) - ',10,0,false);
  readln(OK);

  Print('One more time input old protect key (ASCII) - ',10,0,false);
  readln(KEY);

  if (KEY='') or (OK<>KEY) then begin
    Print('Unprotect fail!',11,0,true);
    halt
  end;

  assign(FF,P); {Open...}
  reset(FF,1);  {...source}

  assign(TF,'TEMP.FP$'); {Open...}
  {$I-}
  rewrite(TF,1);         {...output}
  IOCheck;
  {$I+}

  seek(FF,18);
  repeat
    blockread(FF,BUF,sizeof(BUF),NR);
    for T:=1 to NR do BUF[T]:=PUP(BUF[T]);
    blockwrite(TF,BUF,NR,NW)
  until (NR=0) or (NW<>NR);

  close(FF);
  close(TF);
  erase(FF);
  rename(TF,P)
end;

var C:word;
begin
  writeln;
  Print('FIle Protect 2.00, Copyright 1993 by Pentagram. (KIM, JIN HONG)',15,1,true);

  P:=paramstr(1);
  if paramcount=0 then begin
    Print('Usage: FIP [pathname] [!]',15,3,true);
    Print('''!'' be used when unprotect.',11,0,true);
    halt
  end;

  if paramstr(2)='!' then UnProtect else Protect;
  Print('Complete.',11,1,true)
end.
