uses dos,crt,screen,keyboard;

{$R-}

var reg:registers;
    vmode,points,columns,addr,xboffset,yboffset:integer;
    offset:word;

procedure SetASO(x,y:integer);
begin
  points:=mem[$0040:$0085];

  offset:=columns*(y div points)+(x div 8);
  xboffset:=x mod 8;
  yboffset:=y mod points;

  addr:=memw[$0040:$0063];
  portw[addr]:=$0c;
  portw[addr+1]:=offset div $100;
  portw[addr]:=$0d;
  portw[addr+1]:=offset mod $100;
  memw[$0040:$004e]:=offset;

  portw[addr]:=$08;
  portw[addr+1]:=yboffset;

  with reg do begin
    ah:=$10;
    al:=$00;
    bh:=xboffset;
    bl:=$13
  end;
  intr($10,reg)
end;

var x,y:longint;
    f:text;
    s:string;
begin
  vmode:=mem[$0040:$0049];

  if not (vmode in [0..3,7]) then exit;
  if (vmode=0) or (vmode=1) then columns:=40 else columns:=80;

  cursor(false);
  SetASO(-1,0);

  assign(f,'panning.pas');
  reset(f);

  for y:=0 to 50 do begin
    readln(f,s);
    fwrite(1,26+y,7,s)
  end;

  for y:=0 to 16*50 do begin
    if y mod 16=0 then pause;
    SetASO(-1,y);
    delay(70)
  end;
  pause;

  close(f);

  SetASO(-1,0)
end.