uses crt,screen,fade,textfont,dos;

{$R-}
var Drive,Park_Ok:word;
    Regs:registers;
    Count:word;

const _MaxData=8;
      Max     =60;
      StarNewFont:array[1.._MaxData-1] of FontType=((0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0),
                                           (0,0,0,0,0,0,8,24,8,0,0,0,0,0,0,0),
                                           (0,0,0,0,0,8,8,24,8,8,0,0,0,0,0,0),
                                           (0,0,0,0,4,8,8,60,8,8,16,0,0,0,0,0),
                                           (0,0,0,2,4,4,72,60,10,16,16,32,0,0,0,0),
                                           (0,0,2,2,4,4,200,60,11,16,16,32,32,64,0,0),
                                           (0,0,2,2,4,4,200,60,11,16,16,32,32,64,0,0));
      StarNewLine:array[1..16] of FontType=((0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8),
                                            (0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8),
                                            (0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8),
                                            (0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8),
                                            (0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8),
                                            (0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8),
                                            (0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8),
                                            (0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8),
                                            (0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,8),
                                            (0,0,0,0,0,0,8,8,8,8,8,8,8,8,8,8),
                                            (0,0,0,0,0,8,8,8,8,8,8,8,8,8,8,8),
                                            (0,0,0,0,8,8,8,8,8,8,8,8,8,8,8,8),
                                            (0,0,0,8,8,8,8,8,8,8,8,8,8,8,8,8),
                                            (0,0,8,8,8,8,8,8,8,8,8,8,8,8,8,8),
                                            (0,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8),
                                            (8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8));
      Msg=' (!) The Star Parking 1.20, Copyright 1994 by KIM, JIN HONG. PENTAGRAM... ';

type  BlinkStar=object
        _Viewing,_X,_Y,_C:byte;
        procedure Init;
        procedure SetXY(X,Y:byte);
        procedure Color(C:byte);
        procedure Draw;
      end;

var reg        :registers;
    offset     :word;
    vmode,points,addr,xboffset,yboffset,X:integer;
    FlashStarBlink,BackBlink,ChangedFont:boolean;
    XX,YY,ADDBACK,R,G,B,MW,SX,SY,VL:byte;
    ADD,RI,GI,BI,MI,VLI:shortint;
    ADDH       :longint;
    StarData   :array[1.._MaxData] of byte;
    Star       :array[1..Max] of BlinkStar;
    SaveMainScrn:SCRNARRAY;

procedure SetASO(x,y:integer);
begin
  points:=mem[$0040:$0085];

  offset:=80*(y div points)+(x div 8);
  xboffset:=x mod 8;
  yboffset:=y mod points;

  addr:=memw[$0040:$0063];
  portw[addr]:=$0c;
  portw[addr+1]:=offset div $100;
  portw[addr]:=$0d;
  portw[addr+1]:=offset mod $100;
  memw[$0040:$004e]:=offset;

  portw[addr]:=$08;
  portw[addr+1]:=yboffset;

  with reg do begin
    ah:=$10;
    al:=$00;
    bh:=xboffset;
    bl:=$13
  end;
  intr($10,reg)
end;

procedure BlinkStar.Init;
begin
  _Viewing:=1;
  _X:=random(80)+1;
  _Y:=random(25)+1;
  _C:=random(14)+2
end;

procedure BlinkStar.SetXY;
begin
  _X:=X;
  _Y:=Y
end;

procedure BlinkStar.Color;
begin _C:=C end;

procedure BlinkStar.Draw;
begin
  FWrite(chr(StarData[_Viewing]),_X,_Y,_C);
  if _Viewing<_MaxData then inc(_Viewing) else _Viewing:=1
end;

procedure SetPalette(ORG,R,G,B:byte);
begin
  port[$3C8]:=ORG;
  port[$3C9]:=R;
  port[$3C9]:=G;
  port[$3C9]:=B
end;

procedure Star_Font_Init;
var T:byte;
begin
  StarData[1]:=250;
  StarData[2]:=249;
  StarData[3]:=7;
  StarData[4]:=4;
  StarData[5]:=9;
  StarData[6]:=42;
  StarData[7]:=15;
  StarData[8]:=0;

  if random(3)<>0 then
    for T:=1 to _MaxData-1 do SetFont(StarData[T], StarNewFont[T]);
  SetFont(ord('!'),StarNewLine[1])
end;

procedure Init_Screen;
var T:byte;
begin
  randomize;
  cursor(false);
  SaveMainScrn:=Scrn^;
  SX:=wherex;
  SY:=wherey;

  { saving original palette }
  Save_In_Out;

  for T:=0 to 30 do begin
    Fade_IN_OUT(-1);
    delay(5)
  end;

  SetPalette(0,63,63,63);
  delay(50);

  for T:=0 to 33 do begin
    Fade_IN_OUT(1);
    delay(2)
  end;

  for T:=0 to 63 do begin
    Fade_IN_OUT(-1);
    delay(50)
  end;

  clrscr;
  { original palette loading }
  Recover
end;

procedure Set_Variable_and_Virtual_Screen;
var T:byte;
begin
  { variable setting }
  ADD      :=1;
  ADDH     :=0;
  ADDBACK  :=0;
  RI       :=1;
  GI       :=1;
  BI       :=1;
  R        :=0;
  G        :=62;
  B        :=30;
  X        :=0;
  MW       :=46;
  MI       :=1;
  VL       :=1;
  VLI      :=-1;
  FlashStarBlink:=false;
  BackBlink:=false;

  { OOP. star variable initialize }
  for T:=1 to Max do Star[T].Init;

  { virtual screen message initialize }
  for T:=1 to 160 do FWrite(' ',T,26,0);
  FWrite(Msg,MW,26,1)
end;

procedure Main;
var T:byte;
begin
  repeat
    { variety line of front of message }
    if (VL=1) or (VL=16) then VLI:=-VLI;
    inc(VL,VLI);
    SetFont(ord('!'),StarNewLine[VL]);

    { Background color variety }
    if random(100)=0 then BackBlink:=true;
    if BackBlink then
      if ADDBACK<20 then inc(ADDBACK)
      else begin
        ADDBACK:=0;
        BackBlink:=false
      end;
    if (BackBlink) and (ADDBACK<11) then
      SetPalette(0,ADDBACK,ADDBACK,ADDBACK);
    if (BackBlink) and (ADDBACK>10) then
      SetPalette(0,20-ADDBACK,20-ADDBACK,20-ADDBACK);

    { white flash star }
    if FlashStarBlink then begin
      if random(25)=0 then FlashStarBlink:=false
    end else if random(90)=0 then FlashStarBlink:=true;

    { Message animation }
    if (MW=45) or (MW=70) then MI:=-MI;
    inc(MW,MI);
    FWrite(Msg,MW,26,1);

    { Message color variety }
    if (R=0) or (R=63) then RI:=-RI;
    if (G=0) or (G=63) then GI:=-GI;
    if (B=0) or (B=63) then BI:=-BI;
    inc(R,RI);
    inc(G,GI);
    inc(B,BI);
    SetPalette(1,R,G,B);

    { Star Blink main loop }
    for T:=1 to Max do begin
      { white flash star }
      if FlashStarBlink then begin
        XX:=random(80)+1;
        YY:=random(25)+1;
        FWrite(#197,XX,YY,15)
      end;

      { screen scrolling }
      inc(ADDH);
      if ADDH>20 then begin
        ADDH:=0;
        if (X=1000) or (X=-1) then ADD:=-ADD;
        inc(X,ADD);
        SetASO(X,0)
      end;

      { Star Blinking }
      if Star[T]._Viewing=1 then begin
        if random(50)=0 then Star[T].Draw
      end else Star[T].Draw;
      delay(1);

      { white flash blink }
      if FlashStarBlink then FWrite(#197,XX,YY,0)
    end
  until keypressed;
  mem[0:$41A]:=mem[0:$41C]
end;

procedure Restore;
var T:byte;
begin
  Save_In_Out;
  for T:=0 to 63 do begin
    Fade_IN_OUT(-1);
    delay(30)
  end;

  textmode(co80);  { all done }
  gotoxy(SX,SY);
  Scrn^:=SaveMainScrn
end;

procedure Introdus;
const Star:array[1..5] of FontType=((16,16,16,16,16,16,16,255,16,16,16,16,16,16,16,16),
                                    (2,2,4,4,8,8,208,60,19,32,64,64,128,128,0,0),
                                    (0,0,1,2,132,72,48,16,24,36,66,129,0,0,0,0),
                                    (0,128,128,65,66,36,56,48,80,136,8,4,4,2,2,1),
                                    (32,32,32,32,16,19,28,112,144,16,16,8,8,8,8,8));

var T,X,Y,MX,SMX,Count:byte;
    MI      :shortint;
    Font    :FontType;
begin
  clrscr;

  GetFont(ord('G'),Font);
  for T:=0 to 2 do Font[T]:=(Font[T] shr 3) and $1f;
  for T:=3 to 5 do Font[T]:=(Font[T] shr 2) and $3f;
  for T:=6 to 8 do Font[T]:=(Font[T] shr 1) and $7f;
  SetFont(ord('G'),Font);

  X:=2;
  Y:=0;
  repeat
    FWrite('pentaGram',X,Y,11);
    inc(X,2);
    inc(Y);
    FWrite('pentaGram',X,Y,12);
    delay(30)
  until X=26;

  X:=2;
  Y:=0;
  repeat
    inc(X,2);
    inc(Y);
    FWrite('pentaGram',X,Y,0);
    delay(70)
  until X=24;

  for Y:=25 to 35 do begin
    FWrite(' pentaGram',Y,12,12);
    delay(20)
  end;

  for T:=1 to 5 do SetFont(240+T,Star[T]);

  for X:=1 to 33 do begin
    FWrite(' '#241,X,12,9);
    delay(10)
  end;

  for X:=79 downto 46 do begin
    FWrite(#241' ',X,12,9);
    delay(20)
  end;

  for X:=32 to 48 do begin
    FWrite(#196,X,10,15);
    FWrite(#196,80-X,14,15);
    delay(50)
  end;

  MI:=-1;
  MX:=36;
  Count:=0;
  SMX:=MX;
  repeat
    if (MX=36) or (MX=44) then begin
      MI:=-MI;
      if MI>0 then inc(Count)
    end;

    SCRN^[12,SMX].A:=12;
    SCRN^[12,MX].A:=15;
    SMX:=MX;
    inc(MX,MI);

    if T<5 then inc(T) else T:=1;
    FWrite(chr(240+T),34,12,9);
    FWrite(chr(246-T),46,12,9);
    delay(100)
  until (Count=5) or (keypressed);

  mem[0:$41A]:=mem[0:$41C];
  Save_In_Out;
  for T:=0 to 33 do begin
    Fade_IN_OUT(-1);
    delay(30)
  end;

  for T:=0 to 30 do begin
    Fade_IN_OUT(-1);
    delay(10)
  end;
  textmode(co80)
end;

procedure Parking(Drive,Park_ok :Word);
begin
   Regs.ax := 4352;
   Regs.cx := 0;
   Regs.dx := Drive;
   Intr($13,Regs);

   If Regs.flags <> 0 then Exit;
   Park_ok := 128;

   regs.ax := 3072;
   Regs.cx := 0;
   Regs.Dx := Drive;
   Intr($13,Regs);

   regs.ax := 2048;
   Regs.cx := 0;
   Regs.Dx := Drive;
   Intr($13,Regs);

   regs.ax := 3072;
   Regs.cx := 0;
   Regs.Dx := Drive;
   Intr($13,Regs);
end;

begin
   Park_Ok := 0;
   Drive := $80;

   regs.ax := $800;
   Regs.cx := 0;
   regs.dx := Drive;
   Intr($13,regs);

   Count := Regs.dl;

   If (regs.Flags = 1) or ( Count = 0 ) then begin
     Writeln('Parking Error!');
     Exit
   end else Begin
     If Count > 2 then Count := 2;

     Repeat
        parking(drive,park_ok);
        Inc(Drive);
        Dec(Count)
     Until  Count<>0;

     If Park_Ok = 128 then Begin
       Writeln('Parking Error!');
       Exit
     End;
   end;

  Init_Screen;
  Introdus;
  Star_Font_Init;
  Set_Variable_and_Virtual_Screen;
  Main;
  Restore
end.
