uses dos,crt,bgidriv,graph;

const
       PointX=320;
       PointY=240;

type
      LaserCell=object
        XI,YI,CXI,CYI          :shortint;
        X,Y,CX,CY,Count,Counter:word;
        Color                  :byte;
        procedure Init(C,Col:byte;XXI,YYI:shortint);
        procedure Draw;
      end;

var Drive,Park_Ok:word;
    Regs:registers;
    Count:word;
    Gd,Gm:Integer;
    Lay:LaserCell;

procedure LaserCell.Draw;
begin
  setcolor(Color);
  line(PointX,PointY,X,Y);
  putpixel(X,Y,15);

  if (X=640) or (X=0) then XI:=-XI;
  if (Y=480) or (Y=0) then YI:=-YI;
  inc(Y,YI);
  inc(X,XI);

  setcolor(15);
  line(PointX,PointY,X,Y);

  if Count<Counter then begin
    if (CX=640) or (CX=0) then CXI:=-CXI;
    if (CY=480) or (CY=0) then CYI:=-CYI;
    setcolor(0);
    line(PointX,PointY,CX,CY);
    inc(CY,CYI);
    inc(CX,CXI)
  end else inc(Counter)
end;

procedure LaserCell.Init;
begin
  XI     :=XXI;
  YI     :=YYI;
  X      :=0;
  Y      :=0;
  CXI    :=XI;
  CYI    :=YI;
  CX     :=X;
  CY     :=Y;
  Color  :=Col;
  Count  :=C;
  Counter:=0
end;

procedure Parking(Drive,Park_ok :Word);
Begin
   Regs.ax := 4352;
   Regs.cx := 0;
   Regs.dx := Drive;
   Intr($13,Regs);

   If Regs.flags <> 0 then Exit;
   Park_ok := 128;

   regs.ax := 3072;
   Regs.cx := 0;
   Regs.Dx := Drive;
   Intr($13,Regs);

   regs.ax := 2048;
   Regs.cx := 0;
   Regs.Dx := Drive;
   Intr($13,Regs);

   regs.ax := 3072;
   Regs.cx := 0;
   Regs.Dx := Drive;
   Intr($13,Regs);
End;

Begin
   Park_Ok := 0;
   Drive := $80;

   regs.ax := $800;
   Regs.cx := 0;
   regs.dx := Drive;
   Intr($13,regs);

   Count := Regs.dl;

   If (regs.Flags = 1) or ( Count = 0 ) then begin
     Writeln('Parking Error!');
     Exit
   end else Begin
     If Count > 2 then Count := 2;

     Repeat
        parking(drive,park_ok);
        Inc(Drive);
        Dec(Count)
     Until  Count=0;

     If Park_Ok = 128 then Begin
       Writeln('Parking Error!');
       Exit
     End;
   end;

  Gd := Detect; InitGraph(Gd, Gm, '');
  if GraphResult <> grOk then Halt(1);

  Lay.Init(200,1,-1,-20);
  repeat Lay.Draw until keypressed;
  closegraph
End.
