type
  FCB = record
            FF        : byte;              {must be 0FFh}
            RESERVED1 : array[1..5] of byte; {must be 0s}
            ATTR      : byte;
            DRIVEID   : byte;
            FILENAME  : array[1..11] of char;
            CURBLOCK  : word;
            RECSIZE   : word;
            FILESIZE  : longint;
            DATE      : word;
            TIME      : word;
            RESERVED2 : array[1..8] of byte;
            CURREC    : byte;
            RELATIVE  : longint
          end;

  DTA=record
    sk1:array[1..8] of char;
    ol:array[1..11] of char;
    sk2:array[1..5] of char;
    nl:array[1..11] of char;
    sk3:array[1..29] of char;
  end;

var
  v:fcb;
  d:dta;
  result:boolean;

begin
    asm
      push      ds
      mov       ax,seg d
      mov       ds,ax
      mov       dx,offset d
      mov       ah,1ah
      int       21h
      pop       ds
    end;

    v.ff:=$ff;
    fillchar(v.reserved1,5,0);
    v.attr:=$08; { 08 means VolumdID }
    v.driveid:=ord('C')-64;
    fillchar(v.filename,11,'?');

    asm
      push      ds
      mov       ax,seg v
      mov       ds,ax
      mov       dx,offset v
      mov       ah,11h
      int       21h
      inc       al
      mov       result,al
      pop       ds
    end;

  if result then writeln('Volume:',d.ol)
  else writeln('Volume has no label');
end.
